# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class AdiEmsWebApiV2DtoExportServiceServiceStatus(Model):
    """Contains status/count information for an export service.

    All required parameters must be populated in order to send to Azure.

    :param id: Required. The unique identifier of the export service to which
     this status information belongs
    :type id: str
    :param enabled: Required. Whether the service is currently enabled
    :type enabled: bool
    :param exports_waiting: The count of exports waiting to be processed
    :type exports_waiting: int
    :param exports_pending: The count of exports currently processing
    :type exports_pending: int
    :param exports_processed: The count of exports successfully processed
    :type exports_processed: int
    :param exports_failed: The count of exports that failed processing
    :type exports_failed: int
    :param last_dispatched_time: The last time that an export job was
     dispatched for processing
    :type last_dispatched_time: datetime
    :param last_successful_time: The last time an export completed
     successfully
    :type last_successful_time: datetime
    :param last_unsuccessful_time: The last time an export failed to process
    :type last_unsuccessful_time: datetime
    :param estimated_completion_time: The estimated completion time for all
     waiting exports
    :type estimated_completion_time: datetime
    """

    _validation = {
        'id': {'required': True},
        'enabled': {'required': True},
    }

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'enabled': {'key': 'enabled', 'type': 'bool'},
        'exports_waiting': {'key': 'exportsWaiting', 'type': 'int'},
        'exports_pending': {'key': 'exportsPending', 'type': 'int'},
        'exports_processed': {'key': 'exportsProcessed', 'type': 'int'},
        'exports_failed': {'key': 'exportsFailed', 'type': 'int'},
        'last_dispatched_time': {'key': 'lastDispatchedTime', 'type': 'iso-8601'},
        'last_successful_time': {'key': 'lastSuccessfulTime', 'type': 'iso-8601'},
        'last_unsuccessful_time': {'key': 'lastUnsuccessfulTime', 'type': 'iso-8601'},
        'estimated_completion_time': {'key': 'estimatedCompletionTime', 'type': 'iso-8601'},
    }

    def __init__(self, *, id: str, enabled: bool, exports_waiting: int=None, exports_pending: int=None, exports_processed: int=None, exports_failed: int=None, last_dispatched_time=None, last_successful_time=None, last_unsuccessful_time=None, estimated_completion_time=None, **kwargs) -> None:
        super(AdiEmsWebApiV2DtoExportServiceServiceStatus, self).__init__(**kwargs)
        self.id = id
        self.enabled = enabled
        self.exports_waiting = exports_waiting
        self.exports_pending = exports_pending
        self.exports_processed = exports_processed
        self.exports_failed = exports_failed
        self.last_dispatched_time = last_dispatched_time
        self.last_successful_time = last_successful_time
        self.last_unsuccessful_time = last_unsuccessful_time
        self.estimated_completion_time = estimated_completion_time
