# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class AdiEmsWebApiV2ModelAdminEmsSystem(Model):
    """Represents an EMS system that can be used and accessed by users of the
    website.

    All required parameters must be populated in order to send to Azure.

    :param id: The unique integer identifier of the EMS system.
    :type id: int
    :param name: Required. The unique, user friendly, name of the EMS system.
    :type name: str
    :param dir_adi: Required. The "Dir Adi" URI where the EMS system
     installation is located, used to access the EMS system's resources.
    :type dir_adi: str
    :param dir_collection: The path to the collection location indicating
     where data collections for this EMS system should go.
    :type dir_collection: str
    :param description: A brief summary describing the EMS system and its
     purpose.
    :type description: str
    """

    _validation = {
        'name': {'required': True},
        'dir_adi': {'required': True},
    }

    _attribute_map = {
        'id': {'key': 'id', 'type': 'int'},
        'name': {'key': 'name', 'type': 'str'},
        'dir_adi': {'key': 'dirAdi', 'type': 'str'},
        'dir_collection': {'key': 'dirCollection', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
    }

    def __init__(self, *, name: str, dir_adi: str, id: int=None, dir_collection: str=None, description: str=None, **kwargs) -> None:
        super(AdiEmsWebApiV2ModelAdminEmsSystem, self).__init__(**kwargs)
        self.id = id
        self.name = name
        self.dir_adi = dir_adi
        self.dir_collection = dir_collection
        self.description = description
